OperationalRiskException/Controllers/AssessmentPortalController.cs
using Newtonsoft.Json;
using OperationalRiskException.AuthorizationFilter;
using OperationalRiskException.Core.Enums;
using OperationalRiskException.Core.ViewModels;
using OperationalRiskException.Services.Interfaces;
using OperationalRiskException.Services.Services;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace OperationalRiskException.Controllers
{
    [CustomAuthorize(UserRoleEnum.Champion)]
    public class AssessmentPortalController : Controller
    {
        // GET: AssessmentPortal
        private IAssessmentPortalServices _assessmentPortalServices;

        public AssessmentPortalController()
        {
            _assessmentPortalServices = new AssessmentPortalServices();
        }

        public async Task<ActionResult> Dashboard()
        {
            var user = new CookieController().ReadFromCookie("UserRole");
            var deUser = JsonConvert.DeserializeObject<RoleViewModel>(user);
            string username = deUser.Username;

            var result = await _assessmentPortalServices.GetAllRecords(username);
            return View(result);
        }
        public ActionResult Records()
        {
            var totalScore = _assessmentPortalServices.GetAllScores();
            return View(totalScore);
        }
        public ActionResult CorrectivePlan(int AssSchId)
        {
            if (AssSchId == 0)
                return RedirectToAction("Login", "Account");
            var assSchId = new HttpCookie("AssSchId")
            {
                Value = AssSchId.ToString(),
                Expires = DateTime.Now.AddHours(24)
            };
            Response.Cookies.Add(assSchId);
            var correctList = _assessmentPortalServices.GetCorrectiveFormByUsername(AssSchId, Username());
            if (correctList.Count == 0)
                return RedirectToAction("");

            return View();
        }
    
    public ActionResult CorrectivePlanTest()
    {
            var assSchId = AssessmentSetUpId();
            if (assSchId == 0)
                return RedirectToAction("Login", "Account");
            var result =  _assessmentPortalServices.GetCorrectiveFormByUsername( assSchId, Username());
            return Json(new
            {
                data = result
            }, JsonRequestBehavior.AllowGet);

    }
    public ActionResult TakeTest( int AssSchId=0)
        {
            if (AssSchId == 0)
                return RedirectToAction("Login","Account");



            var assSchId = new HttpCookie("AssSchId")
            {
                Value = AssSchId.ToString(),
                Expires = DateTime.Now.AddHours(24)
            };
            Response.Cookies.Add(assSchId);
     
            
            return View();
        }
        public async Task<ActionResult> GetAllQuestionsAsync()
        {
            //string username = new CookieController().ReadFromCookie("Username");
            var assSchId = AssessmentSetUpId();
            if (assSchId==0)
                return RedirectToAction("Login", "Account");
            var result = await _assessmentPortalServices.GetAllRecordAllQuestions(Username(), assSchId);
            return Json(new
            {
                data = result
            }, JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public async Task<JsonResult> UploadAnswerAsync(HttpPostedFileBase fileBase )
        {
            var records = String.Empty;
            if (Request.Files.Count > 0)
            {
                string catId = Request["CategoryId"];

                //  Get all files from Request object  
                HttpFileCollectionBase Files = Request.Files;
                HttpPostedFileBase FileUpload = Files[0];
                int CateID = int.Parse(catId);
                // tdata.ExecuteCommand("truncate table OtherCompanyAssets");  
                if (FileUpload.ContentType == "application/vnd.ms-excel" || FileUpload.ContentType == "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet")
                {
                    string filename = FileUpload.FileName;
                    string targetpath = Server.MapPath("~/Doc/");
                    if (!Directory.Exists(targetpath))
                    {
                        Directory.CreateDirectory(targetpath);
                    }
                    string absolutePath= "quiz" + DateTime.Now.ToString("MMddyyyyHHmmss") + filename;
                    string pathToExcelFile = targetpath + absolutePath;
                    FileUpload.SaveAs(pathToExcelFile);
                    var fileProperty = new FileUploadVM {
                        FilePath = absolutePath,
                        QuestionCategoryId=CateID
                    };
                  var Checker=await _assessmentPortalServices.SaveFile(fileProperty, Username(), AssessmentSetUpId());
                    records = Checker? pathToExcelFile : "failed";
                    
                }

            }
            return Json(new
            {
                data = records
            }, JsonRequestBehavior.AllowGet);


        }

        public async Task<ActionResult> SaveQuestionByCategoryAsync(SaveQuestionVM questionVM )
        {
            var scheduleId = AssessmentSetUpId();
         var check=   await _assessmentPortalServices.SaveAssessment(questionVM, Username(), scheduleId);
            //redirect if the answer is no
          
            return Json(new
            {
                data = check,
                scheduleId,
            }, JsonRequestBehavior.AllowGet);

        }

        public async Task<ActionResult> SaveQuestionByCorrectivePlanTest(SaveQuestionVM questionVM)
        {
            var scheduleId = AssessmentSetUpId();
            var check = await _assessmentPortalServices.SaveCorrectivePlan(questionVM, Username(), scheduleId);
            //redirect if the answer is no

            return Json(new
            {
                data = check,
                scheduleId,
            }, JsonRequestBehavior.AllowGet);

        }

        [HttpGet]
        public async Task<JsonResult> GetAllResult(int QuestionCatId)
        {
            var records = await _assessmentPortalServices.GetAllSavedAssessment( Username(), QuestionCatId, AssessmentSetUpId());

            return Json(new
            {
                data = records
            }, JsonRequestBehavior.AllowGet);


        }
        [HttpGet]
        public async Task<JsonResult> GetAllUsersResult(int QuestionCatId)
        {
            var records = await _assessmentPortalServices.GetAllSavedAssessment(Username(), QuestionCatId, AssessmentSetUpId());

            return Json(new
            {
                data = records
            }, JsonRequestBehavior.AllowGet);


        }
        private int AssessmentSetUpId()
        {
            var aCookie = System.Web.HttpContext.Current.Request.Cookies["AssSchId"];
           return aCookie.Value != null ? int.Parse(aCookie.Value) : 0;
        }
        private string Username()
        {
            var user = new CookieController().ReadFromCookie("UserRole");
            var deUser = JsonConvert.DeserializeObject<RoleViewModel>(user);
            return deUser.Username;
        }


    }
}

OperationalRiskException/Views/AssessmentPortal/CorrectivePlan.cshtml
@{
    Layout = null;
}

<!DOCTYPE html>

<html>
<head>
    <meta charset="utf-8" />
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>@ViewBag.Title   </title>
    @Scripts.Render("~/bundles/modernizr")
    <link rel="stylesheet" href="~/Content/vendors/mdi/css/materialdesignicons.min.css">
    <link rel="stylesheet" href="~/Content/vendors/base/vendor.bundle.base.css">
    <link rel="stylesheet" href="~/Content/css/style.css">
    <link rel="shortcut icon" href="images/favicon.png" />
    <link rel="stylesheet" href="~/Content/css/jquery-ui.min.css">
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/jqueryval")
    <link rel="stylesheet" href="~/Content/Site.css">
    <link rel="stylesheet" href="~/Content/css/toastr.css">

</head>
<body>
    <div class="container-scroller">
        <div class="loader"></div>
        @Html.Partial("_HeaderView")
    <div class="container-fluid page-body-wrapper">
        <nav class="sidebar sidebar-offcanvas" id="sidebar">
            <ul class="nav">

                <li class="nav-item">

                    <div class="" id="ui-basic">
                        <ul class="nav flex-column sub-menu" id="list-menu">
                        </ul>
                    </div>
                </li>

            </ul>
        </nav>
        <div class="main-panel">
            <div class="content-wrapper">
                <div class="row">

                    <div class="col-sm-12">
                        <div class="card" id="session">
                            <h2 class="card-header text-center">Section (<span id="questionCategory">Corrective Plan</span>) </h2>



                            <div class="card-body">
                                <h5 class="card-title"></h5>
                                <form id="form-questn">
                                </form>
                            </div>
                            <div class="card-footer float-btn">
                                <span class="" id="btnSave">  </span>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <footer class="footer">
                <div class="d-sm-flex justify-content-center justify-content-sm-between">
                    <span class="text-muted text-center text-sm-left d-block d-sm-inline-block">Copyright © 2020 <a href="https://www.ubagroup.com/" target="_blank">UBA Group</a>. All rights reserved.</span>
                </div>
            </footer>
        </div>
    </div>
    </div>


    <script type="text/javascript">
        var allQuestions = [];
        
    var optionListUrl = '@Url.Action("CorrectivePlanTest", "AssessmentPortal")';
        questionArray();
    function questionArray() {
        $.ajax({
            type: 'GET',
            url: optionListUrl,
           // data: "",
            dataType: 'json',
            success: function (data) {
                allQuestions = data.data;
                   displayCategoryQuestions(data.data)
            }
        });
        }

        function displayCategoryQuestions(records) {
            $("#btnSave").append($('<button type="submit" onclick="submitForm()" class="btn btn-danger mr-2">' + 'Submit' + '</button>'));
            $("#form-questn").empty();
            $.each(records, function (i, value) {
                $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> (' + (i + 1) + ')  ' + value.QuestionText + ' </h4><div class="option" > <input type="text" class="form-control" required id="opt' + (value.QuestionId) + '" placeholder="Please provide a corrective plan inside the box" name="' + value.QuestionId + '"/></div> </div>'));
            })
            //Testing checked answer.
        }
 function validation() {
            // file Upload
            // Input type
      
     var fieldCount =0;

     var getcount = allQuestions.length;
     $.each($("#form-questn").serializeArray(), function (i, value) {
         if (value.value.length == 0) {

         }
         else
             fieldCount = fieldCount + 1;
     });

            if (fieldCount != getcount) {
                console.log('fieldCount', fieldCount);
                 console.log('getcount',getcount);
                getcount =getcount- fieldCount  ;
                console.log(getcount);
                toastr.error('kindly, select all the entries <br/>  '+ getcount +'  fill(s) left!!!', "Validation");
                return false;
            }
            return true;
        }
 function submitForm() {
            // first check ur local db
            // if exist patch value to the db
            // else not check online;
            // and save into local data
            // if there's nothing online
         var check = validation();

            if (check) {
                var formObject = $("#form-questn").serializeArray();
                var formData = { Questionlists: formObject};
                var url = '@Url.Action("SaveQuestionByCorrectivePlanTest", "AssessmentPortal")';
                var saveData = $.ajax({
                    type: 'POST',
                    url: url,
                    data: JSON.stringify(formData),
                    contentType: 'application/json; charset=utf-8',
                    dataType: "json",
                    success: function (resultData) {
                       

                        Dashboard()
                    }
                });
            }

        }
        function Dashboard() {
    var url = '@Url.Action("Dashboard", "AssessmentPortal")';
            window.location.href = url;
}

    </script>
    @Scripts.Render("~/bundles/bootstrap")
    <script src="~/Content/vendors/base/vendor.bundle.base.js"></script>
    <script src="~/Scripts/js/toastr.js"></script>
    <script src="~/Scripts/js/off-canvas.js"></script>
    <script src="~/Scripts/js/hoverable-collapse.js"></script>
    <script src="~/Scripts/js/template.js"></script>
    <script src="~/Scripts/js/loader.js"></script>

    @Scripts.Render("~/bundles/jquery-ui")

</body>
</html>

OperationalRiskException/Views/AssessmentPortal/Dashboard.cshtml
@model OperationalRiskException.Core.ViewModels.ChampionDashboardVM
@{
    ViewBag.Title = "Dashboard";
    Layout = "~/Views/Shared/_TestLayout.cshtml";
}


    <div class="content-wrapper">

        <div class="row">
            <div class="col-md-12 grid-margin">
                <div class="d-flex justify-content-between flex-wrap">
                    <div class="d-flex align-items-end flex-wrap">
                        <div class="mr-md-3 mr-xl-5">
                            <h2>Welcome back,</h2>

                        </div>

                    </div>

                    <div class="d-flex justify-content-between align-items-end flex-wrap">

                    </div>
                </div>
                <div class="d-flex">
                    <i class="mdi mdi-home text-muted hover-cursor"></i>
                    <p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp;Dashboard&nbsp;&nbsp;</p>
                    <p class="text-primary mb-0 hover-cursor"></p>
                </div>
            </div>
        </div>
        <div class="row" id="proBanner">
            <div class="col-md-12 grid-margin">
                <div class="card bg-gradient-primary border-0">
                    @{

                        if (Model.IsTestAvailable)
                        {
                            foreach (var list in Model.ListOfAvailableTest)
                            {
                                <div class="card-body py-3 px-4 d-flex align-items-center justify-content-between flex-wrap">
                                    <p class="mb-0 text-white font-weight-medium">You have been provision to answer operational risk exception questions.</p>
                                    <div class="d-flex">
                                        @* <a href="https://github.com/Bootstrapdash/MajesticAdmin-Free-Bootstrap-Admin-Template" target="_blank" class="btn btn-outline-light mr-2">Download free version</a>*@
                                        <a href="@Url.Action("TakeTest", "AssessmentPortal", new { AssSchId=list.AssessmentScheduleId })" target="_blank" class="btn btn-outline-light mr-2 bg-gradient-danger border-0">
                                            Click here to Start
                                        </a>

                                    </div>
                                </div>
                            }
                        }
                        else
                        {
                            <div class="card-body py-3 px-4 d-flex align-items-center justify-content-between flex-wrap">
                                <p class="mb-0 text-white font-weight-medium">No Test Available at the moment</p>
                                <div class="d-flex">
                                    @* <a href="https://github.com/Bootstrapdash/MajesticAdmin-Free-Bootstrap-Admin-Template" target="_blank" class="btn btn-outline-light mr-2">Download free version</a>*@


                                </div>
                            </div>
                        }
                    }
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12 grid-margin stretch-card">
                <div class="card tablecontainer">
                    <div class="card-body">
                        <h4 class="card-title"></h4>
                        <p class="card-description">
                            Scores
                        </p>
                        <div class="table-responsive pt-3">
                            <table class="table table-bordered" id="myTable">
                                <thead>
                                    <tr>

                                        <th>
                                            Total Question(s) (TQ)
                                        </th>
                                        <th>
                                            Number of Exception(s) (Ex)
                                        </th>
                                        <th>
                                            Risk  Scores(%)
                                          
                                        </th>

                                        <th>
                                            Comment
                                        </th>

                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach (var items in Model.Scores)
                                    {
                                        <tr>
                                          

                                            <td>
                                                @items.TotalScore
                                            </td>
                                            <td>
                                                @items.ScoreNo
                                            </td>
                                            <td>

                                                @items.Risk
                                            </td>
                                            <td>
                                                @{ if (@items.Risk > 60)
                                                    {
                                                        <span class="badge badge-outline-danger">High Risk</span>
                                                    }
                                                    else if (@items.Risk > 40 && @items.Risk < 60)
                                                    {
                                                        <span class="badge badge-outline-warning">Medium Risk</span>
                                                    }
                                                    else
                                                    {
                                                        <span class="badge badge-outline-success">low Risk</span>
                                                    }

                                                }
                                            </td>

                                        </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>